Package groovy.lang

## Interface Writable

- All Known Implementing Classes:
    `Attribute`, `Attribute`, `Attributes`, `Attributes`, `BaseTemplate`, `ConfigObject`, `FilteredAttributes`, `FilteredAttributes`, `FilteredNodeChildren`, `FilteredNodeChildren`, `GPathResult`, `GPathResult`, `GString`, `GStringImpl`, `JsonBuilder`, `NoChildren`, `NoChildren`, `Node`, `Node`, `NodeChild`, `NodeChild`, `NodeChildren`, `NodeChildren`, `NodeParents`, `NodeParents`, `ReplacementNode`, `ReplacementNode`, `WritableFile`, `WritablePath`, `WritablePath`, `YamlBuilder`

      public interface Writable

  Represents an object which is capable of writing itself to a text stream in a more efficient format than just creating a toString() representation of itself. This mechanism is particularly useful for templates and such like.

  It is worth noting that writable implementations often override their toString() implementation as well to allow rendering the same result directly to a String; however this is not required.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Writer` | `writeTo​(Writer out)` | Writes this object to the given writer.

- - ### Method Detail

    - #### writeTo

          Writer writeTo​(Writer out)
                  throws IOException

      Writes this object to the given writer.

      This is used to defer content creation until the point when it is streamed to the output destination. Oftentimes, content will be defined but not necessarily created (as is may be the case with a Closure definition.) In that case, the output is then 'deferred' to the point when it is serialized to the writer. This class may be used whenever an object should be responsible for creating its own textual representation, but creating the entire output as a single String would be inefficient (such as outputting a multi-gigabyte XML document.)

      Parameters:
        `out` - the Writer to which this Writable should output its data.
      Returns:
        the Writer that was passed
      Throws:
        `IOException` - if an error occurred while outputting data to the writer